library(DropletUtils)
library(Matrix)
library(Seurat)
library(dplyr)

setwd("C:/...")

# read from .mtx
counts = readMM('sparse_matrix.mtx')
# obs data.frame
obs = read.csv('obs.csv', header = T)
# var data.frame
vars = read.csv('var.csv', row.names = 1)
# obsm UMAP coords
obsm = read.csv('obsm.csv', header = T)

colnames(counts) <- vars$name
row.names(counts) <- obs[,1]

row.names(obs) <- obs[,1]
row.names(obsm) <- obs[,1]

scvi_umap = obsm[, c('X_umap1', 'X_umap2')]
row.names(scvi_umap) <- row.names(obs)

# Make Seurat object
seurat_obj = CreateSeuratObject(counts = t(counts), meta.data = obs) #Seurat version 3
seurat_obj[['scvi_umap']] =CreateDimReducObject(embeddings = scvi_umap %>% as.matrix() , key="SCVI_", assay =DefaultAssay(seurat_obj))

#seurat_obj = CreateSeuratObject(raw.data =  t(counts), meta.data = obs) #Seurat version 2

# save to .rds
save(seurat_obj,file = 'seurat_obj.rds')
